'use strict';

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var promisify = require('./utils/promisify');
var resolve = require('browser-resolve');
var resolveAsync = promisify(resolve);
var builtins = require('./builtins');
var path = require('path');
var glob = require('glob');

var Resolver = function () {
  function Resolver() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, Resolver);

    this.options = options;
    this.cache = new _map2.default();
  }

  (0, _createClass3.default)(Resolver, [{
    key: 'resolve',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(filename, parent) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var resolved;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.resolveInternal(filename, parent, options, resolveAsync);

              case 2:
                resolved = _context.sent;
                return _context.abrupt('return', this.saveCache(filename, parent, resolved));

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function resolve(_x3, _x4) {
        return _ref.apply(this, arguments);
      }

      return resolve;
    }()
  }, {
    key: 'resolveSync',
    value: function resolveSync(filename, parent) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

      var resolved = this.resolveInternal(filename, parent, options, resolve.sync);
      return this.saveCache(filename, parent, resolved);
    }
  }, {
    key: 'resolveInternal',
    value: function resolveInternal(filename, parent, options, resolver) {
      filename = filename.split('@')[0];
      var key = this.getCacheKey(filename, parent);
      if (this.cache.has(key)) {
        return this.cache.get(key);
      }

      if (glob.hasMagic(filename)) {
        return { path: path.resolve(path.dirname(parent), filename) };
      }

      var extensions = (0, _keys2.default)(this.options.extensions);
      if (parent) {
        var parentExt = path.extname(parent);
        // parent's extension given high priority
        extensions = [parentExt].concat((0, _toConsumableArray3.default)(extensions.filter(function (ext) {
          return ext !== parentExt;
        })));
      }

      return resolver(filename, (0, _assign2.default)({
        filename: parent,
        paths: this.options.paths,
        modules: builtins,
        extensions: extensions,
        packageFilter: function packageFilter(pkg, pkgfile) {
          // Expose the path to the package.json file
          pkg.pkgfile = pkgfile;

          // libraries like d3.js specifies node.js specific files in the "main" which breaks the build
          // we use the "module" or "jsnext:main" field to get the full dependency tree if available
          var main = [pkg.module, pkg['jsnext:main']].find(function (entry) {
            return typeof entry === 'string';
          });

          if (main) {
            pkg.main = main;
          }

          return pkg;
        }
      }, options));
    }
  }, {
    key: 'getCacheKey',
    value: function getCacheKey(filename, parent) {
      return (parent ? path.dirname(parent) : '') + ':' + filename;
    }
  }, {
    key: 'saveCache',
    value: function saveCache(filename, parent, resolved) {
      if (Array.isArray(resolved)) {
        resolved = { path: resolved[0], pkg: resolved[1] };
      } else if (typeof resolved === 'string') {
        resolved = { path: resolved, pkg: null };
      }

      this.cache.set(this.getCacheKey(filename, parent), resolved);
      return resolved;
    }
  }]);
  return Resolver;
}();

module.exports = Resolver;