'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Asset = require('../Asset');
var postcss = require('postcss');
var valueParser = require('postcss-value-parser');
var postcssTransform = require('../transforms/postcss');
var CssSyntaxError = require('postcss/lib/css-syntax-error');

var URL_RE = /url\s*\("?(?![a-z]+:)/;
var IMPORT_RE = /@import/;
var PROTOCOL_RE = /^[a-z]+:/;

var CSSAsset = function (_Asset) {
  (0, _inherits3.default)(CSSAsset, _Asset);

  function CSSAsset(name, pkg, options) {
    (0, _classCallCheck3.default)(this, CSSAsset);

    var _this = (0, _possibleConstructorReturn3.default)(this, (CSSAsset.__proto__ || (0, _getPrototypeOf2.default)(CSSAsset)).call(this, name, pkg, options));

    _this.type = 'css';
    return _this;
  }

  (0, _createClass3.default)(CSSAsset, [{
    key: 'install',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = [];
                _context.t1 = _toConsumableArray3.default;
                _context.next = 4;
                return (0, _get3.default)(CSSAsset.prototype.__proto__ || (0, _getPrototypeOf2.default)(CSSAsset.prototype), 'install', this).call(this);

              case 4:
                _context.t2 = _context.sent;
                _context.t3 = (0, _context.t1)(_context.t2);
                _context.t4 = [{ name: 'postcss-modules', dev: true }];
                return _context.abrupt('return', _context.t0.concat.call(_context.t0, _context.t3, _context.t4));

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function install() {
        return _ref.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: 'mightHaveDependencies',
    value: function mightHaveDependencies() {
      return !/\.css$/.test(this.name) || IMPORT_RE.test(this.contents) || URL_RE.test(this.contents);
    }
  }, {
    key: 'parse',
    value: function parse(code) {
      var root = postcss.parse(code, { from: this.name, to: this.name });
      return new CSSAst(code, root);
    }
  }, {
    key: 'collectDependencies',
    value: function collectDependencies() {
      var _this2 = this;

      this.ast.root.walkAtRules('import', function (rule) {
        var params = valueParser(rule.params).nodes;

        var _params = (0, _toArray3.default)(params),
            name = _params[0],
            media = _params.slice(1);

        var dep = void 0;
        if (name.type === 'string') {
          dep = name.value;
        } else if (name.type === 'function' && name.value === 'url' && name.nodes.length) {
          dep = name.nodes[0].value;
        }

        if (!dep) {
          throw new Error('Could not find import name for ' + rule);
        }

        if (PROTOCOL_RE.test(dep)) {
          return;
        }

        media = valueParser.stringify(media).trim();
        _this2.addDependency(dep, { media: media, loc: rule.source.start });

        rule.remove();
        _this2.ast.dirty = true;
      });

      this.ast.root.walkDecls(function (decl) {
        if (URL_RE.test(decl.value)) {
          var parsed = valueParser(decl.value);
          var dirty = false;

          parsed.walk(function (node) {
            if (node.type === 'function' && node.value === 'url' && node.nodes.length) {
              var url = _this2.addURLDependency(node.nodes[0].value, {
                loc: decl.source.start
              });
              dirty = node.nodes[0].value !== url;
              node.nodes[0].value = url;
            }
          });

          if (dirty) {
            decl.value = parsed.toString();
            _this2.ast.dirty = true;
          }
        }
      });
    }
  }, {
    key: 'transform',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return postcssTransform(this);

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function transform() {
        return _ref2.apply(this, arguments);
      }

      return transform;
    }()
  }, {
    key: 'getCSSAst',
    value: function getCSSAst() {
      // Converts the ast to a CSS ast if needed, so we can apply postcss transforms.
      if (!(this.ast instanceof CSSAst)) {
        this.ast = CSSAsset.prototype.parse.call(this, this.ast.render());
      }

      return this.ast.root;
    }
  }, {
    key: 'generate',
    value: function generate() {
      var css = this.ast ? this.ast.render() : this.contents;

      var js = '';
      if (this.options.hmr) {
        this.addDependency('_css_loader');

        js = '\n        var reloadCSS = require(\'_css_loader\');\n        module.hot.dispose(reloadCSS);\n        module.hot.accept(reloadCSS);\n      ';
      }

      if (this.cssModules) {
        js += 'module.exports = ' + (0, _stringify2.default)(this.cssModules, false, 2) + ';';
      }

      return { css: css, js: js };
    }
  }, {
    key: 'generateErrorMessage',
    value: function generateErrorMessage(err) {
      // Wrap the error in a CssSyntaxError if needed so we can generate a code frame
      if (err.loc && !err.showSourceCode) {
        err = new CssSyntaxError(err.message, err.loc.line, err.loc.column, this.contents);
      }

      err.message = err.reason || err.message;
      err.loc = {
        line: err.line,
        column: err.column
      };

      if (err.showSourceCode) {
        err.codeFrame = err.showSourceCode();
        err.highlightedCodeFrame = err.showSourceCode(true);
      }

      return err;
    }
  }]);
  return CSSAsset;
}(Asset);

var CSSAst = function () {
  function CSSAst(css, root) {
    (0, _classCallCheck3.default)(this, CSSAst);

    this.css = css;
    this.root = root;
    this.dirty = false;
  }

  (0, _createClass3.default)(CSSAst, [{
    key: 'render',
    value: function render() {
      var _this3 = this;

      if (this.dirty) {
        this.css = '';
        postcss.stringify(this.root, function (c) {
          return _this3.css += c;
        });
      }

      return this.css;
    }
  }]);
  return CSSAst;
}();

module.exports = CSSAsset;