'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Asset = require('../Asset');
var glob = require('glob');
var micromatch = require('micromatch');
var path = require('path');

var GlobAsset = function (_Asset) {
  (0, _inherits3.default)(GlobAsset, _Asset);

  function GlobAsset(name, pkg, options) {
    (0, _classCallCheck3.default)(this, GlobAsset);

    var _this = (0, _possibleConstructorReturn3.default)(this, (GlobAsset.__proto__ || (0, _getPrototypeOf2.default)(GlobAsset)).call(this, name, pkg, options));

    _this.type = null; // allows this asset to be included in any type bundle
    return _this;
  }

  (0, _createClass3.default)(GlobAsset, [{
    key: 'load',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var regularExpressionSafeName, files, re, matches, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, file, match, parts, relative;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                regularExpressionSafeName = this.name;

                if (process.platform === 'win32') regularExpressionSafeName = regularExpressionSafeName.replace(/\\/g, '/');

                files = glob.sync(regularExpressionSafeName, {
                  strict: true,
                  nodir: true
                });
                re = micromatch.makeRe(regularExpressionSafeName, { capture: true });
                matches = {};
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 8;


                for (_iterator = (0, _getIterator3.default)(files); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  file = _step.value;
                  match = file.match(re);
                  parts = match.slice(1).filter(Boolean).reduce(function (a, p) {
                    return a.concat(p.split('/'));
                  }, []);
                  relative = './' + path.relative(path.dirname(this.name), file.normalize('NFC'));

                  set(matches, parts, relative);
                  this.addDependency(relative);
                }

                _context.next = 16;
                break;

              case 12:
                _context.prev = 12;
                _context.t0 = _context['catch'](8);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 16:
                _context.prev = 16;
                _context.prev = 17;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 19:
                _context.prev = 19;

                if (!_didIteratorError) {
                  _context.next = 22;
                  break;
                }

                throw _iteratorError;

              case 22:
                return _context.finish(19);

              case 23:
                return _context.finish(16);

              case 24:
                return _context.abrupt('return', matches);

              case 25:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[8, 12, 16, 24], [17,, 19, 23]]);
      }));

      function load() {
        return _ref.apply(this, arguments);
      }

      return load;
    }()
  }, {
    key: 'generate',
    value: function generate() {
      return {
        js: 'module.exports = ' + _generate(this.contents) + ';'
      };
    }
  }]);
  return GlobAsset;
}(Asset);

function _generate(matches) {
  var indent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (typeof matches === 'string') {
    return 'require(' + (0, _stringify2.default)(matches) + ')';
  }

  var res = indent + '{';

  var first = true;
  for (var key in matches) {
    if (!first) {
      res += ',';
    }

    res += '\n' + indent + '  ' + (0, _stringify2.default)(key) + ': ' + _generate(matches[key], indent + '  ');
    first = false;
  }

  res += '\n' + indent + '}';
  return res;
}

function set(obj, path, value) {
  for (var i = 0; i < path.length - 1; i++) {
    var part = path[i];

    if (obj[part] == null) {
      obj[part] = {};
    }

    obj = obj[part];
  }

  obj[path[path.length - 1]] = value;
}

module.exports = GlobAsset;