'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Asset = require('../Asset');
var _parse = require('posthtml-parser');
var api = require('posthtml/lib/api');
var urlJoin = require('../utils/urlJoin');
var render = require('posthtml-render');
var posthtmlTransform = require('../transforms/posthtml');
var isURL = require('../utils/is-url');

// A list of all attributes that should produce a dependency
// Based on https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes
var ATTRS = {
  src: ['script', 'img', 'audio', 'video', 'source', 'track', 'iframe', 'embed'],
  href: ['link', 'a'],
  poster: ['video']
};

var HTMLAsset = function (_Asset) {
  (0, _inherits3.default)(HTMLAsset, _Asset);

  function HTMLAsset(name, pkg, options) {
    (0, _classCallCheck3.default)(this, HTMLAsset);

    var _this = (0, _possibleConstructorReturn3.default)(this, (HTMLAsset.__proto__ || (0, _getPrototypeOf2.default)(HTMLAsset)).call(this, name, pkg, options));

    _this.type = 'html';
    _this.isAstDirty = false;
    return _this;
  }

  (0, _createClass3.default)(HTMLAsset, [{
    key: 'parse',
    value: function parse(code) {
      var res = _parse(code);
      res.walk = api.walk;
      res.match = api.match;
      return res;
    }
  }, {
    key: 'collectDependencies',
    value: function collectDependencies() {
      var _this2 = this;

      this.ast.walk(function (node) {
        if (node.attrs) {
          for (var attr in node.attrs) {
            var elements = ATTRS[attr];
            // Check for virtual paths
            if (node.tag === 'a' && node.attrs[attr].lastIndexOf('.') < 1) {
              continue;
            }
            if (elements && elements.includes(node.tag)) {
              var assetPath = _this2.addURLDependency(decodeURIComponent(node.attrs[attr]));
              if (!isURL(assetPath)) {
                assetPath = urlJoin(_this2.options.publicURL, assetPath);
              }
              node.attrs[attr] = assetPath;
              _this2.isAstDirty = true;
            }
          }
        }

        return node;
      });
    }
  }, {
    key: 'pretransform',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return posthtmlTransform(this);

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function pretransform() {
        return _ref.apply(this, arguments);
      }

      return pretransform;
    }()
  }, {
    key: 'generate',
    value: function generate() {
      var html = this.isAstDirty ? render(this.ast) : this.contents;
      return { html: html };
    }
  }]);
  return HTMLAsset;
}(Asset);

module.exports = HTMLAsset;