'use strict';

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('babel-core'),
    BabelFile = _require.File;

var _traverse = require('babel-traverse').default;
var codeFrame = require('babel-code-frame');
var _collectDependencies = require('../visitors/dependencies');
var walk = require('babylon-walk');
var Asset = require('../Asset');
var babylon = require('babylon');
var insertGlobals = require('../visitors/globals');
var fsVisitor = require('../visitors/fs');
var babel = require('../transforms/babel');
var _generate = require('babel-generator').default;
var uglify = require('../transforms/uglify');

var IMPORT_RE = /\b(?:import\b|export\b|require\s*\()/;
var GLOBAL_RE = /\b(?:process|__dirname|__filename|global|Buffer)\b/;
var FS_RE = /\breadFileSync\b/;
var SW_RE = /\bnavigator\s*\.\s*serviceWorker\s*\.\s*register\s*\(/;
var WORKER_RE = /\bnew\s*Worker\s*\(/;

var JSAsset = function (_Asset) {
  (0, _inherits3.default)(JSAsset, _Asset);

  function JSAsset(name, pkg, options) {
    (0, _classCallCheck3.default)(this, JSAsset);

    var _this = (0, _possibleConstructorReturn3.default)(this, (JSAsset.__proto__ || (0, _getPrototypeOf2.default)(JSAsset)).call(this, name, pkg, options));

    _this.type = 'js';
    _this.globals = new _map2.default();
    _this.isAstDirty = false;
    _this.isES6Module = false;
    _this.outputCode = null;
    _this.cacheData.env = {};
    return _this;
  }

  (0, _createClass3.default)(JSAsset, [{
    key: 'shouldInvalidate',
    value: function shouldInvalidate(cacheData) {
      for (var key in cacheData.env) {
        if (cacheData.env[key] !== process.env[key]) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: 'mightHaveDependencies',
    value: function mightHaveDependencies() {
      return this.isAstDirty || !/.js$/.test(this.name) || IMPORT_RE.test(this.contents) || GLOBAL_RE.test(this.contents) || SW_RE.test(this.contents) || WORKER_RE.test(this.contents);
    }
  }, {
    key: 'getParserOptions',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var options, _options$plugins, file;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // Babylon options. We enable a few plugins by default.
                options = {
                  filename: this.name,
                  allowReturnOutsideFunction: true,
                  allowHashBang: true,
                  ecmaVersion: Infinity,
                  strictMode: false,
                  sourceType: 'module',
                  locations: true,
                  plugins: ['exportExtensions', 'dynamicImport']
                };

                // Check if there is a babel config file. If so, determine which parser plugins to enable

                _context.t0 = this.package && this.package.babel;

                if (_context.t0) {
                  _context.next = 6;
                  break;
                }

                _context.next = 5;
                return this.getConfig(['.babelrc', '.babelrc.js']);

              case 5:
                _context.t0 = _context.sent;

              case 6:
                this.babelConfig = _context.t0;

                if (this.babelConfig) {
                  file = new BabelFile({ filename: this.name });

                  (_options$plugins = options.plugins).push.apply(_options$plugins, (0, _toConsumableArray3.default)(file.parserOpts.plugins));
                }

                return _context.abrupt('return', options);

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getParserOptions() {
        return _ref.apply(this, arguments);
      }

      return getParserOptions;
    }()
  }, {
    key: 'parse',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(code) {
        var options;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.getParserOptions();

              case 2:
                options = _context2.sent;
                return _context2.abrupt('return', babylon.parse(code, options));

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function parse(_x) {
        return _ref2.apply(this, arguments);
      }

      return parse;
    }()
  }, {
    key: 'traverse',
    value: function traverse(visitor) {
      return _traverse(this.ast, visitor, null, this);
    }
  }, {
    key: 'traverseFast',
    value: function traverseFast(visitor) {
      return walk.simple(this.ast, visitor, this);
    }
  }, {
    key: 'collectDependencies',
    value: function collectDependencies() {
      this.traverseFast(_collectDependencies);
    }
  }, {
    key: 'pretransform',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return babel(this);

              case 2:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function pretransform() {
        return _ref3.apply(this, arguments);
      }

      return pretransform;
    }()
  }, {
    key: 'transform',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(this.dependencies.has('fs') && FS_RE.test(this.contents))) {
                  _context4.next = 4;
                  break;
                }

                _context4.next = 3;
                return this.parseIfNeeded();

              case 3:
                this.traverse(fsVisitor);

              case 4:
                if (!GLOBAL_RE.test(this.contents)) {
                  _context4.next = 8;
                  break;
                }

                _context4.next = 7;
                return this.parseIfNeeded();

              case 7:
                walk.ancestor(this.ast, insertGlobals, this);

              case 8:
                if (!this.isES6Module) {
                  _context4.next = 11;
                  break;
                }

                _context4.next = 11;
                return babel(this);

              case 11:
                if (!this.options.minify) {
                  _context4.next = 14;
                  break;
                }

                _context4.next = 14;
                return uglify(this);

              case 14:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function transform() {
        return _ref4.apply(this, arguments);
      }

      return transform;
    }()
  }, {
    key: 'generate',
    value: function generate() {
      // TODO: source maps
      var code = this.isAstDirty ? _generate(this.ast).code : this.outputCode || this.contents;
      if (this.globals.size > 0) {
        code = (0, _from2.default)(this.globals.values()).join('\n') + '\n' + code;
      }

      return {
        js: code
      };
    }
  }, {
    key: 'generateErrorMessage',
    value: function generateErrorMessage(err) {
      var loc = err.loc;
      if (loc) {
        err.codeFrame = codeFrame(this.contents, loc.line, loc.column + 1);
        err.highlightedCodeFrame = codeFrame(this.contents, loc.line, loc.column + 1, { highlightCode: true });
      }

      return err;
    }
  }]);
  return JSAsset;
}(Asset);

module.exports = JSAsset;