'use strict';

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CSSAsset = require('./CSSAsset');
var localRequire = require('../utils/localRequire');
var promisify = require('../utils/promisify');

var LESSAsset = function (_CSSAsset) {
  (0, _inherits3.default)(LESSAsset, _CSSAsset);

  function LESSAsset() {
    (0, _classCallCheck3.default)(this, LESSAsset);
    return (0, _possibleConstructorReturn3.default)(this, (LESSAsset.__proto__ || (0, _getPrototypeOf2.default)(LESSAsset)).apply(this, arguments));
  }

  (0, _createClass3.default)(LESSAsset, [{
    key: 'install',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = [];
                _context.t1 = _toConsumableArray3.default;
                _context.next = 4;
                return (0, _get3.default)(LESSAsset.prototype.__proto__ || (0, _getPrototypeOf2.default)(LESSAsset.prototype), 'install', this).call(this);

              case 4:
                _context.t2 = _context.sent;
                _context.t3 = (0, _context.t1)(_context.t2);
                _context.t4 = [{ name: 'less', dev: true }];
                return _context.abrupt('return', _context.t0.concat.call(_context.t0, _context.t3, _context.t4));

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function install() {
        return _ref.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: 'parse',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(code) {
        var less, render, opts, res;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return localRequire('less', this.name);

              case 2:
                less = _context2.sent;
                render = promisify(less.render.bind(less));
                _context2.t1 = this.package.less;

                if (_context2.t1) {
                  _context2.next = 9;
                  break;
                }

                _context2.next = 8;
                return this.getConfig(['.lessrc', '.lessrc.js']);

              case 8:
                _context2.t1 = _context2.sent;

              case 9:
                _context2.t0 = _context2.t1;

                if (_context2.t0) {
                  _context2.next = 12;
                  break;
                }

                _context2.t0 = {};

              case 12:
                opts = _context2.t0;

                opts.filename = this.name;
                opts.plugins = (opts.plugins || []).concat(urlPlugin(this));

                _context2.next = 17;
                return render(code, opts);

              case 17:
                res = _context2.sent;

                res.render = function () {
                  return res.css;
                };
                return _context2.abrupt('return', res);

              case 20:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function parse(_x) {
        return _ref2.apply(this, arguments);
      }

      return parse;
    }()
  }, {
    key: 'collectDependencies',
    value: function collectDependencies() {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(this.ast.imports), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var dep = _step.value;

          this.addDependency(dep, { includedInParent: true });
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }]);
  return LESSAsset;
}(CSSAsset);

function urlPlugin(asset) {
  return {
    install: function install(less, pluginManager) {
      var visitor = new less.visitors.Visitor({
        visitUrl: function visitUrl(node) {
          node.value.value = asset.addURLDependency(node.value.value, node.currentFileInfo.filename);
          return node;
        }
      });

      visitor.run = visitor.visit;
      pluginManager.addVisitor(visitor);
    }
  };
}

module.exports = LESSAsset;