'use strict';

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var createEvaluator = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(asset) {
    var Evaluator, utils, resolver, CustomEvaluator;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return localRequire('stylus/lib/visitor/evaluator', asset.name);

          case 2:
            Evaluator = _context3.sent;
            _context3.next = 5;
            return localRequire('stylus/lib/utils', asset.name);

          case 5:
            utils = _context3.sent;
            resolver = new Resolver(asset.options);

            // This is a custom stylus evaluator that extends stylus with support for the node
            // require resolution algorithm. It also adds all dependencies to the parcel asset
            // tree so the file watcher works correctly, etc.

            CustomEvaluator = function (_Evaluator) {
              (0, _inherits3.default)(CustomEvaluator, _Evaluator);

              function CustomEvaluator() {
                (0, _classCallCheck3.default)(this, CustomEvaluator);
                return (0, _possibleConstructorReturn3.default)(this, (CustomEvaluator.__proto__ || (0, _getPrototypeOf2.default)(CustomEvaluator)).apply(this, arguments));
              }

              (0, _createClass3.default)(CustomEvaluator, [{
                key: 'visitImport',
                value: function visitImport(imported) {
                  var node = this.visit(imported.path).first;
                  var path = node.string;
                  if (node.name !== 'url' && path && !URL_RE.test(path)) {
                    try {
                      // First try resolving using the node require resolution algorithm.
                      // This allows stylus files in node_modules to be resolved properly.
                      // If we find something, update the AST so stylus gets the absolute path to load later.
                      node.string = resolver.resolveSync(path, imported.filename).path;
                      asset.addDependency(node.string, { includedInParent: true });
                    } catch (err) {
                      // If we couldn't resolve, try the normal stylus resolver.
                      // We just need to do this to keep track of the dependencies - stylus does the real work.

                      // support optional .styl
                      if (!/\.styl$/i.test(path)) {
                        path += '.styl';
                      }

                      var found = utils.find(path, this.paths, this.filename);
                      if (!found) {
                        found = utils.lookupIndex(node.string, this.paths, this.filename);
                      }

                      if (!found) {
                        var nodeName = imported.once ? 'require' : 'import';
                        throw new Error('failed to locate @' + nodeName + ' file ' + node.string);
                      }

                      var _iteratorNormalCompletion = true;
                      var _didIteratorError = false;
                      var _iteratorError = undefined;

                      try {
                        for (var _iterator = (0, _getIterator3.default)(found), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                          var file = _step.value;

                          asset.addDependency(file, { includedInParent: true });
                        }
                      } catch (err) {
                        _didIteratorError = true;
                        _iteratorError = err;
                      } finally {
                        try {
                          if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                          }
                        } finally {
                          if (_didIteratorError) {
                            throw _iteratorError;
                          }
                        }
                      }
                    }
                  }

                  // Done. Let stylus do its thing.
                  return (0, _get3.default)(CustomEvaluator.prototype.__proto__ || (0, _getPrototypeOf2.default)(CustomEvaluator.prototype), 'visitImport', this).call(this, imported);
                }
              }]);
              return CustomEvaluator;
            }(Evaluator);

            return _context3.abrupt('return', CustomEvaluator);

          case 9:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function createEvaluator(_x2) {
    return _ref3.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CSSAsset = require('./CSSAsset');
var localRequire = require('../utils/localRequire');
var Resolver = require('../Resolver');

var URL_RE = /^(?:url\s*\(\s*)?['"]?(?:[#/]|(?:https?:)?\/\/)/i;

var StylusAsset = function (_CSSAsset) {
  (0, _inherits3.default)(StylusAsset, _CSSAsset);

  function StylusAsset() {
    (0, _classCallCheck3.default)(this, StylusAsset);
    return (0, _possibleConstructorReturn3.default)(this, (StylusAsset.__proto__ || (0, _getPrototypeOf2.default)(StylusAsset)).apply(this, arguments));
  }

  (0, _createClass3.default)(StylusAsset, [{
    key: 'install',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = [];
                _context.t1 = _toConsumableArray3.default;
                _context.next = 4;
                return (0, _get3.default)(StylusAsset.prototype.__proto__ || (0, _getPrototypeOf2.default)(StylusAsset.prototype), 'install', this).call(this);

              case 4:
                _context.t2 = _context.sent;
                _context.t3 = (0, _context.t1)(_context.t2);
                _context.t4 = [{ name: 'stylus', dev: true }];
                return _context.abrupt('return', _context.t0.concat.call(_context.t0, _context.t3, _context.t4));

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function install() {
        return _ref.apply(this, arguments);
      }

      return install;
    }()
  }, {
    key: 'parse',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(code) {
        var _this2 = this;

        var stylus, opts, style;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return localRequire('stylus', this.name);

              case 2:
                stylus = _context2.sent;
                _context2.t0 = this.package.stylus;

                if (_context2.t0) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 7;
                return this.getConfig(['.stylusrc', '.stylusrc.js']);

              case 7:
                _context2.t0 = _context2.sent;

              case 8:
                opts = _context2.t0;
                style = stylus(code, opts);

                style.set('filename', this.name);
                style.set('include css', true);
                _context2.t1 = style;
                _context2.next = 15;
                return createEvaluator(this);

              case 15:
                _context2.t2 = _context2.sent;

                _context2.t1.set.call(_context2.t1, 'Evaluator', _context2.t2);

                // Setup a handler for the URL function so we add dependencies for linked assets.
                style.define('url', function (node) {
                  var filename = _this2.addURLDependency(node.val, node.filename);
                  return new stylus.nodes.Literal('url(' + (0, _stringify2.default)(filename) + ')');
                });

                return _context2.abrupt('return', style);

              case 19:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function parse(_x) {
        return _ref2.apply(this, arguments);
      }

      return parse;
    }()
  }, {
    key: 'collectDependencies',
    value: function collectDependencies() {
      // Do nothing. Dependencies are collected by our custom evaluator.
    }
  }, {
    key: 'generateErrorMessage',
    value: function generateErrorMessage(err) {
      var index = err.message.indexOf('\n');
      err.codeFrame = err.message.slice(index + 1);
      err.message = err.message.slice(0, index);
      return err;
    }
  }]);
  return StylusAsset;
}(CSSAsset);

module.exports = StylusAsset;