'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Asset = require('../Asset');

var WebManifestAsset = function (_Asset) {
  (0, _inherits3.default)(WebManifestAsset, _Asset);

  function WebManifestAsset(name, pkg, options) {
    (0, _classCallCheck3.default)(this, WebManifestAsset);

    var _this = (0, _possibleConstructorReturn3.default)(this, (WebManifestAsset.__proto__ || (0, _getPrototypeOf2.default)(WebManifestAsset)).call(this, name, pkg, options));

    _this.type = 'webmanifest';
    return _this;
  }

  (0, _createClass3.default)(WebManifestAsset, [{
    key: 'parse',
    value: function parse(content) {
      return JSON.parse(content);
    }
  }, {
    key: 'collectDependencies',
    value: function collectDependencies() {
      if (Array.isArray(this.ast.icons)) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = (0, _getIterator3.default)(this.ast.icons), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var icon = _step.value;

            icon.src = this.addURLDependency(icon.src);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }

      if (Array.isArray(this.ast.screenshots)) {
        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = (0, _getIterator3.default)(this.ast.screenshots), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var shot = _step2.value;

            shot.src = this.addURLDependency(shot.src);
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }
      }

      if (this.ast.serviceworker && this.ast.serviceworker.src) {
        this.ast.serviceworker.src = this.addURLDependency(this.ast.serviceworker.src);
      }
    }
  }, {
    key: 'generate',
    value: function generate() {
      return {
        webmanifest: (0, _stringify2.default)(this.ast)
      };
    }
  }]);
  return WebManifestAsset;
}(Asset);

module.exports = WebManifestAsset;