'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var bundle = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(main, command) {
    var Bundler, bundler, server;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // Require bundler here so the help command is fast
            Bundler = require('../');


            if (command.name() === 'build') {
              process.env.NODE_ENV = 'production';
            } else {
              process.env.NODE_ENV = process.env.NODE_ENV || 'development';
            }

            bundler = new Bundler(main, command);

            if (!(command.name() === 'serve')) {
              _context.next = 10;
              break;
            }

            _context.next = 6;
            return bundler.serve(command.port || 1234, command.https);

          case 6:
            server = _context.sent;

            if (command.open) {
              require('opn')((command.https ? 'https' : 'http') + '://localhost:' + server.address().port);
            }
            _context.next = 11;
            break;

          case 10:
            bundler.bundle();

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function bundle(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

require('v8-compile-cache');
var chalk = require('chalk');
var program = require('commander');
var version = require('../package.json').version;

program.version(version);

program.command('serve [input]').description('starts a development server').option('-p, --port <port>', 'set the port to serve on. defaults to 1234', parseInt).option('-h, --hmr-port <port>', 'set the port to serve HMR websockets, defaults to random', parseInt).option('--hmr-hostname <hostname>', 'set the hostname of HMR websockets, defaults to location.hostname of current window').option('--https', 'serves files over HTTPS').option('-o, --open', 'automatically open in default browser').option('-d, --out-dir <path>', 'set the output directory. defaults to "dist"').option('--public-url <url>', 'set the public URL to serve on. defaults to the same as the --out-dir option').option('--no-hmr', 'disable hot module replacement').option('--no-cache', 'disable the filesystem cache').option('-V, --version', 'output the version number').action(bundle);

program.command('watch [input]').description('starts the bundler in watch mode').option('-d, --out-dir <path>', 'set the output directory. defaults to "dist"').option('--public-url <url>', 'set the public URL to serve on. defaults to the same as the --out-dir option').option('--no-hmr', 'disable hot module replacement').option('--no-cache', 'disable the filesystem cache').action(bundle);

program.command('build [input]').description('bundles for production').option('-d, --out-dir <path>', 'set the output directory. defaults to "dist"').option('--public-url <url>', 'set the public URL to serve on. defaults to the same as the --out-dir option').option('--no-minify', 'disable minification').option('--no-cache', 'disable the filesystem cache').action(bundle);

program.command('help [command]').description('display help information for a command').action(function (command) {
  var cmd = program.commands.find(function (c) {
    return c.name() === command;
  }) || program;
  cmd.help();
});

program.on('--help', function () {
  console.log('');
  console.log('  Run `' + chalk.bold('parcel help <command>') + '` for more information on specific commands');
  console.log('');
});

// Make serve the default command
var args = process.argv;
if (!args[2] || !program.commands.some(function (c) {
  return c.name() === args[2];
})) {
  args.splice(2, 0, 'serve');
}

program.parse(args);