'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _set = require('babel-runtime/core-js/set');

var _set2 = _interopRequireDefault(_set);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = require('fs');
var path = require('path');
var Packager = require('./Packager');

var prelude = {};

prelude.source = function () {
  return prelude._source || (prelude._source = fs.readFileSync(path.join(__dirname, '../builtins/prelude.js'), 'utf8').trim());
};

prelude.minified = function () {
  return prelude._minified || (prelude._minified = fs.readFileSync(path.join(__dirname, '../builtins/prelude.js'), 'utf8').trim());
};

var JSPackager = function (_Packager) {
  (0, _inherits3.default)(JSPackager, _Packager);

  function JSPackager() {
    (0, _classCallCheck3.default)(this, JSPackager);
    return (0, _possibleConstructorReturn3.default)(this, (JSPackager.__proto__ || (0, _getPrototypeOf2.default)(JSPackager)).apply(this, arguments));
  }

  (0, _createClass3.default)(JSPackager, [{
    key: 'start',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var preludeCode;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this.first = true;
                this.dedupe = new _map2.default();
                this.bundleLoaders = new _set2.default();
                this.externalModules = new _set2.default();

                preludeCode = this.options.minify ? prelude.minified() : prelude.source();
                _context.next = 7;
                return this.dest.write(preludeCode + '({');

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function start() {
        return _ref.apply(this, arguments);
      }

      return start;
    }()
  }, {
    key: 'addAsset',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(asset) {
        var deps, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _ref3, _ref4, dep, mod, bundles, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, child;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!this.dedupe.has(asset.generated.js)) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt('return');

              case 2:

                // Don't dedupe when HMR is turned on since it messes with the asset ids
                if (!this.options.hmr) {
                  this.dedupe.set(asset.generated.js, asset.id);
                }

                deps = {};
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context2.prev = 7;
                _iterator = (0, _getIterator3.default)(asset.depAssets);

              case 9:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context2.next = 45;
                  break;
                }

                _ref3 = _step.value;
                _ref4 = (0, _slicedToArray3.default)(_ref3, 2);
                dep = _ref4[0];
                mod = _ref4[1];

                if (!(dep.dynamic && this.bundle.childBundles.has(mod.parentBundle))) {
                  _context2.next = 40;
                  break;
                }

                bundles = [this.getBundleSpecifier(mod.parentBundle)];
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context2.prev = 19;

                for (_iterator2 = (0, _getIterator3.default)(mod.parentBundle.siblingBundles); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                  child = _step2.value;

                  if (!child.isEmpty) {
                    bundles.push(this.getBundleSpecifier(child));
                    this.bundleLoaders.add(child.type);
                  }
                }

                _context2.next = 27;
                break;

              case 23:
                _context2.prev = 23;
                _context2.t0 = _context2['catch'](19);
                _didIteratorError2 = true;
                _iteratorError2 = _context2.t0;

              case 27:
                _context2.prev = 27;
                _context2.prev = 28;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 30:
                _context2.prev = 30;

                if (!_didIteratorError2) {
                  _context2.next = 33;
                  break;
                }

                throw _iteratorError2;

              case 33:
                return _context2.finish(30);

              case 34:
                return _context2.finish(27);

              case 35:
                bundles.push(mod.id);
                deps[dep.name] = bundles;
                this.bundleLoaders.add(mod.type);
                _context2.next = 42;
                break;

              case 40:
                deps[dep.name] = this.dedupe.get(mod.generated.js) || mod.id;

                // If the dep isn't in this bundle, add it to the list of external modules to preload.
                // Only do this if this is the root JS bundle, otherwise they will have already been
                // loaded in parallel with this bundle as part of a dynamic import.
                if (!this.bundle.assets.has(mod) && (!this.bundle.parentBundle || this.bundle.parentBundle.type !== 'js')) {
                  this.externalModules.add(mod);
                  this.bundleLoaders.add(mod.type);
                }

              case 42:
                _iteratorNormalCompletion = true;
                _context2.next = 9;
                break;

              case 45:
                _context2.next = 51;
                break;

              case 47:
                _context2.prev = 47;
                _context2.t1 = _context2['catch'](7);
                _didIteratorError = true;
                _iteratorError = _context2.t1;

              case 51:
                _context2.prev = 51;
                _context2.prev = 52;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 54:
                _context2.prev = 54;

                if (!_didIteratorError) {
                  _context2.next = 57;
                  break;
                }

                throw _iteratorError;

              case 57:
                return _context2.finish(54);

              case 58:
                return _context2.finish(51);

              case 59:
                _context2.next = 61;
                return this.writeModule(asset.id, asset.generated.js, deps);

              case 61:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[7, 47, 51, 59], [19, 23, 27, 35], [28,, 30, 34], [52,, 54, 58]]);
      }));

      function addAsset(_x) {
        return _ref2.apply(this, arguments);
      }

      return addAsset;
    }()
  }, {
    key: 'getBundleSpecifier',
    value: function getBundleSpecifier(bundle) {
      var name = path.basename(bundle.name);
      if (bundle.entryAsset) {
        return [name, bundle.entryAsset.id];
      }

      return name;
    }
  }, {
    key: 'writeModule',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(id, code) {
        var deps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var wrapped;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                wrapped = this.first ? '' : ',';

                wrapped += id + ':[function(require,module,exports) {\n' + (code || '') + '\n},';
                wrapped += (0, _stringify2.default)(deps);
                wrapped += ']';

                this.first = false;
                _context3.next = 7;
                return this.dest.write(wrapped);

              case 7:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function writeModule(_x3, _x4) {
        return _ref5.apply(this, arguments);
      }

      return writeModule;
    }()
  }, {
    key: 'addAssetToBundle',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(asset) {
        var _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, child;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                this.bundle.addAsset(asset);
                if (!asset.parentBundle) {
                  asset.parentBundle = this.bundle;
                }

                // Add all dependencies as well
                _iteratorNormalCompletion3 = true;
                _didIteratorError3 = false;
                _iteratorError3 = undefined;
                _context4.prev = 5;
                _iterator3 = (0, _getIterator3.default)(asset.depAssets.values());

              case 7:
                if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                  _context4.next = 14;
                  break;
                }

                child = _step3.value;
                _context4.next = 11;
                return this.addAssetToBundle(child, this.bundle);

              case 11:
                _iteratorNormalCompletion3 = true;
                _context4.next = 7;
                break;

              case 14:
                _context4.next = 20;
                break;

              case 16:
                _context4.prev = 16;
                _context4.t0 = _context4['catch'](5);
                _didIteratorError3 = true;
                _iteratorError3 = _context4.t0;

              case 20:
                _context4.prev = 20;
                _context4.prev = 21;

                if (!_iteratorNormalCompletion3 && _iterator3.return) {
                  _iterator3.return();
                }

              case 23:
                _context4.prev = 23;

                if (!_didIteratorError3) {
                  _context4.next = 26;
                  break;
                }

                throw _iteratorError3;

              case 26:
                return _context4.finish(23);

              case 27:
                return _context4.finish(20);

              case 28:
                _context4.next = 30;
                return this.addAsset(asset);

              case 30:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[5, 16, 20, 28], [21,, 23, 27]]);
      }));

      function addAssetToBundle(_x5) {
        return _ref6.apply(this, arguments);
      }

      return addAssetToBundle;
    }()
  }, {
    key: 'writeBundleLoaders',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var bundleLoader, loads, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, bundleType, loader, asset, preload, _iteratorNormalCompletion5, _didIteratorError5, _iteratorError5, _iterator5, _step5, mod;

        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!(this.bundleLoaders.size === 0)) {
                  _context5.next = 2;
                  break;
                }

                return _context5.abrupt('return', false);

              case 2:
                bundleLoader = this.bundler.loadedAssets.get(require.resolve('../builtins/bundle-loader'));

                if (!(this.externalModules.size > 0 && !bundleLoader)) {
                  _context5.next = 9;
                  break;
                }

                _context5.next = 6;
                return this.bundler.getAsset('_bundle_loader');

              case 6:
                bundleLoader = _context5.sent;
                _context5.next = 9;
                return this.addAssetToBundle(bundleLoader);

              case 9:
                if (bundleLoader) {
                  _context5.next = 11;
                  break;
                }

                return _context5.abrupt('return');

              case 11:

                // Generate a module to register the bundle loaders that are needed
                loads = 'var b=require(' + bundleLoader.id + ');';
                _iteratorNormalCompletion4 = true;
                _didIteratorError4 = false;
                _iteratorError4 = undefined;
                _context5.prev = 15;
                _iterator4 = (0, _getIterator3.default)(this.bundleLoaders);

              case 17:
                if (_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done) {
                  _context5.next = 30;
                  break;
                }

                bundleType = _step4.value;
                loader = this.options.bundleLoaders[bundleType];

                if (!loader) {
                  _context5.next = 27;
                  break;
                }

                _context5.next = 23;
                return this.bundler.getAsset(loader);

              case 23:
                asset = _context5.sent;
                _context5.next = 26;
                return this.addAssetToBundle(asset);

              case 26:
                loads += 'b.register(' + (0, _stringify2.default)(bundleType) + ',require(' + asset.id + '));';

              case 27:
                _iteratorNormalCompletion4 = true;
                _context5.next = 17;
                break;

              case 30:
                _context5.next = 36;
                break;

              case 32:
                _context5.prev = 32;
                _context5.t0 = _context5['catch'](15);
                _didIteratorError4 = true;
                _iteratorError4 = _context5.t0;

              case 36:
                _context5.prev = 36;
                _context5.prev = 37;

                if (!_iteratorNormalCompletion4 && _iterator4.return) {
                  _iterator4.return();
                }

              case 39:
                _context5.prev = 39;

                if (!_didIteratorError4) {
                  _context5.next = 42;
                  break;
                }

                throw _iteratorError4;

              case 42:
                return _context5.finish(39);

              case 43:
                return _context5.finish(36);

              case 44:
                if (!(this.externalModules.size > 0)) {
                  _context5.next = 67;
                  break;
                }

                preload = [];
                _iteratorNormalCompletion5 = true;
                _didIteratorError5 = false;
                _iteratorError5 = undefined;
                _context5.prev = 49;

                for (_iterator5 = (0, _getIterator3.default)(this.externalModules); !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                  mod = _step5.value;

                  preload.push([mod.generateBundleName(), mod.id]);
                }

                _context5.next = 57;
                break;

              case 53:
                _context5.prev = 53;
                _context5.t1 = _context5['catch'](49);
                _didIteratorError5 = true;
                _iteratorError5 = _context5.t1;

              case 57:
                _context5.prev = 57;
                _context5.prev = 58;

                if (!_iteratorNormalCompletion5 && _iterator5.return) {
                  _iterator5.return();
                }

              case 60:
                _context5.prev = 60;

                if (!_didIteratorError5) {
                  _context5.next = 63;
                  break;
                }

                throw _iteratorError5;

              case 63:
                return _context5.finish(60);

              case 64:
                return _context5.finish(57);

              case 65:
                if (this.bundle.entryAsset) {
                  preload.push(this.bundle.entryAsset.id);
                }

                loads += 'b.load(' + (0, _stringify2.default)(preload) + ');';

              case 67:
                _context5.next = 69;
                return this.writeModule(0, loads, {});

              case 69:
                return _context5.abrupt('return', true);

              case 70:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this, [[15, 32, 36, 44], [37,, 39, 43], [49, 53, 57, 65], [58,, 60, 64]]);
      }));

      function writeBundleLoaders() {
        return _ref7.apply(this, arguments);
      }

      return writeBundleLoaders;
    }()
  }, {
    key: 'end',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var entry, asset;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                entry = [];

                // Add the HMR runtime if needed.

                if (!this.options.hmr) {
                  _context6.next = 8;
                  break;
                }

                _context6.next = 4;
                return this.bundler.getAsset(require.resolve('../builtins/hmr-runtime'));

              case 4:
                asset = _context6.sent;
                _context6.next = 7;
                return this.addAssetToBundle(asset);

              case 7:
                entry.push(asset.id);

              case 8:
                _context6.next = 10;
                return this.writeBundleLoaders();

              case 10:
                if (!_context6.sent) {
                  _context6.next = 12;
                  break;
                }

                entry.push(0);

              case 12:

                if (this.bundle.entryAsset && this.externalModules.size === 0) {
                  entry.push(this.bundle.entryAsset.id);
                }

                _context6.next = 15;
                return this.dest.end('},{},' + (0, _stringify2.default)(entry) + ')');

              case 15:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function end() {
        return _ref8.apply(this, arguments);
      }

      return end;
    }()
  }]);
  return JSPackager;
}(Packager);

module.exports = JSPackager;