'use strict';

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var JSPackager = require('./JSPackager');
var CSSPackager = require('./CSSPackager');
var HTMLPackager = require('./HTMLPackager');
var RawPackager = require('./RawPackager');

var PackagerRegistry = function () {
  function PackagerRegistry() {
    (0, _classCallCheck3.default)(this, PackagerRegistry);

    this.packagers = new _map2.default();

    this.add('js', JSPackager);
    this.add('css', CSSPackager);
    this.add('html', HTMLPackager);
  }

  (0, _createClass3.default)(PackagerRegistry, [{
    key: 'add',
    value: function add(type, packager) {
      if (typeof packager === 'string') {
        packager = require(packager);
      }

      this.packagers.set(type, packager);
    }
  }, {
    key: 'has',
    value: function has(type) {
      return this.packagers.has(type);
    }
  }, {
    key: 'get',
    value: function get(type) {
      return this.packagers.get(type) || RawPackager;
    }
  }]);
  return PackagerRegistry;
}();

module.exports = PackagerRegistry;