'use strict';

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var getConfig = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(asset) {
    var config, postcssModulesConfig, postcssModules;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.t0 = asset.package.postcss;

            if (_context2.t0) {
              _context2.next = 5;
              break;
            }

            _context2.next = 4;
            return asset.getConfig(['.postcssrc', '.postcssrc.js', 'postcss.config.js']);

          case 4:
            _context2.t0 = _context2.sent;

          case 5:
            config = _context2.t0;

            if (!(!config && !asset.options.minify)) {
              _context2.next = 8;
              break;
            }

            return _context2.abrupt('return');

          case 8:

            config = config || {};

            postcssModulesConfig = {
              getJSON: function getJSON(filename, json) {
                return asset.cssModules = json;
              }
            };


            if (config.plugins && config.plugins['postcss-modules']) {
              postcssModulesConfig = (0, _assign2.default)(config.plugins['postcss-modules'], postcssModulesConfig);
              delete config.plugins['postcss-modules'];
            }

            _context2.next = 13;
            return loadPlugins(config.plugins, asset.name);

          case 13:
            config.plugins = _context2.sent;

            if (!config.modules) {
              _context2.next = 19;
              break;
            }

            _context2.next = 17;
            return localRequire('postcss-modules', asset.name);

          case 17:
            postcssModules = _context2.sent;

            config.plugins.push(postcssModules(postcssModulesConfig));

          case 19:
            if (!asset.options.minify) {
              _context2.next = 30;
              break;
            }

            _context2.t1 = config.plugins;
            _context2.t2 = cssnano;
            _context2.next = 24;
            return asset.getConfig(['cssnano.config.js']);

          case 24:
            _context2.t3 = _context2.sent;

            if (_context2.t3) {
              _context2.next = 27;
              break;
            }

            _context2.t3 = {};

          case 27:
            _context2.t4 = _context2.t3;
            _context2.t5 = (0, _context2.t2)(_context2.t4);

            _context2.t1.push.call(_context2.t1, _context2.t5);

          case 30:

            config.from = asset.name;
            config.to = asset.name;
            return _context2.abrupt('return', config);

          case 33:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function getConfig(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var localRequire = require('../utils/localRequire');
var loadPlugins = require('../utils/loadPlugins');
var postcss = require('postcss');
var cssnano = require('cssnano');

module.exports = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(asset) {
    var config, res;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return getConfig(asset);

          case 2:
            config = _context.sent;

            if (config) {
              _context.next = 5;
              break;
            }

            return _context.abrupt('return');

          case 5:
            _context.next = 7;
            return asset.parseIfNeeded();

          case 7:
            _context.next = 9;
            return postcss(config.plugins).process(asset.getCSSAst(), config);

          case 9:
            res = _context.sent;


            asset.ast.css = res.css;
            asset.ast.dirty = false;

          case 12:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();