'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('uglify-es'),
    minify = _require.minify;

module.exports = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(asset) {
    var code, customConfig, options, result;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return asset.parseIfNeeded();

          case 2:

            // Convert AST into JS
            code = asset.generate().js;
            _context.next = 5;
            return asset.getConfig(['.uglifyrc']);

          case 5:
            customConfig = _context.sent;
            options = {
              warnings: true,
              mangle: {
                toplevel: true
              },
              compress: {
                drop_console: true
              }
            };


            if (customConfig) {
              options = (0, _assign2.default)(options, customConfig);
            }

            result = minify(code, options);

            if (!result.error) {
              _context.next = 11;
              break;
            }

            throw result.error;

          case 11:

            // Log all warnings
            if (result.warnings) {
              result.warnings.forEach(function (warning) {
                // TODO: warn this using the logger
                console.log(warning);
              });
            }

            // babel-generator did our code generation for us, so remove the old AST
            asset.ast = null;
            asset.outputCode = result.code;
            asset.isAstDirty = false;

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();