'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var loadEnv = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(filepath) {
    var _this = this;

    var NODE_ENV, dotenvFiles;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            NODE_ENV = process.env.NODE_ENV || 'development';
            dotenvFiles = ['.env.' + NODE_ENV + '.local', '.env.' + NODE_ENV,
            // Don't include `.env.local` for `test` environment
            // since normally you expect tests to produce the same
            // results for everyone
            NODE_ENV !== 'test' && '.env.local', '.env'].filter(Boolean);
            _context2.next = 4;
            return _promise2.default.all(dotenvFiles.map(function () {
              var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dotenvFile) {
                var envPath;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return config.resolve(filepath, [dotenvFile]);

                      case 2:
                        envPath = _context.sent;

                        if (envPath) {
                          dotenv.config({ path: envPath });
                        }

                      case 4:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function loadEnv(_x) {
    return _ref.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var config = require('./config');
var dotenv = require('dotenv');

module.exports = loadEnv;