'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var promisify = require('./promisify');
var fs = require('fs');
var mkdirp = require('mkdirp');

exports.readFile = promisify(fs.readFile);
exports.writeFile = promisify(fs.writeFile);
exports.stat = promisify(fs.stat);
exports.readdir = promisify(fs.readdir);

exports.exists = function (filename) {
  return new _promise2.default(function (resolve) {
    fs.exists(filename, resolve);
  });
};

exports.existsSync = function (filename) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return fs.existsSync.apply(fs, [filename].concat(args));
};

exports.mkdirp = promisify(mkdirp);