'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var dbg = require('debug')('parcel:installPackage');
var spawn = require('cross-spawn');
var config = require('./config');
var path = require('path');

module.exports = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(dir, name) {
    var location;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return config.resolve(dir, ['yarn.lock', 'package.json']);

          case 2:
            location = _context.sent;
            return _context.abrupt('return', new _promise2.default(function (resolve, reject) {
              var install = void 0;
              var options = {
                cwd: location ? path.dirname(location) : dir
              };

              if (location && path.basename(location) === 'yarn.lock') {
                dbg('yarn', ['add', name, '--dev'], options);
                install = spawn('yarn', ['add', name, '--dev'], options);
              } else {
                dbg('npm', ['install', name, '--save-dev'], options);
                install = spawn('npm', ['install', name, '--save-dev'], options);
              }

              install.stdout.pipe(process.stdout);
              install.stderr.pipe(process.stderr);

              install.on('close', function (code) {
                if (code !== 0) {
                  return reject(new Error('Failed to install ' + name + '.'));
                }
                return resolve();
              });
            }));

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports.sync = function (dir, name) {
  var location = config.resolveSync(dir, ['yarn.lock', 'package.json']);

  var install = void 0;
  var options = {
    cwd: location ? path.dirname(location) : dir,
    stdio: 'inherit'
  };

  if (location && path.basename(location) === 'yarn.lock') {
    dbg('yarn', ['add', name, '--dev'], options);
    install = spawn.sync('yarn', ['add', name, '--dev'], options);
  } else {
    dbg('npm', ['install', name, '--save-dev'], options);
    install = spawn.sync('npm', ['install', name, '--save-dev'], options);
  }
  return install;
};