'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var localRequire = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(name, path) {
    var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var resolved;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            dbg('localRequire', { name: name, path: path, opts: opts });
            resolved = localResolve(name, path, opts);

            if (!(resolved instanceof Error)) {
              _context.next = 4;
              break;
            }

            throw resolved;

          case 4:
            dbg('localRequire:resolved', { name: name, path: path, opts: opts, resolved: resolved });
            return _context.abrupt('return', require(resolved));

          case 6:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function localRequire(_x4, _x5) {
    return _ref.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var dbg = require('debug')('parcel:localRequire');

var _require = require('path'),
    dirname = _require.dirname;

var resolve = require('resolve');
var install = require('./installPackage').sync;
var Path = require('path');

var cache = new _map2.default();

function localResolve(name, path) {
  var opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var triedInstall = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  var _name$split = name.split('@'),
      _name$split2 = (0, _slicedToArray3.default)(_name$split, 2),
      base = _name$split2[0],
      version = _name$split2[1];

  var dep = base.split('/')[0];
  var final = version ? dep + '@' + version : dep;
  dbg('localResolve', { name: name, path: path, opts: opts, triedInstall: triedInstall });
  if (path == null) {
    path = process.cwd();
  }
  var basedir = dirname(path);
  var key = basedir + ':' + base;
  var resolved = opts.noCache ? null : cache.get(key);
  if (!resolved) {
    try {
      resolved = resolve.sync(base, { basedir: basedir });
    } catch (e) {
      var ext = Path.parse(name).ext;
      var shouldInstall = (ext == '' || ext == 'js') && !name.startsWith('_') && !name.startsWith('/') && !name.startsWith('.') && !opts.noInstall;
      if (e.code === 'MODULE_NOT_FOUND' && shouldInstall) {
        // dbg('localResolve:install', {name, path});
        dbg('localResolve:install', { name: name, path: path, dep: dep, version: version, final: final });
        install(path, final);
        return localResolve(name, path, opts, true);
      } else {
        if (ext == '') {
          dbg('localResolve:install:failed', { name: name, path: path, err: e });
        }
      }
      throw e;
    }
    if (!opts.noCache) {
      cache.set(key, resolved);
    }
  }

  return resolved;
}

module.exports = localRequire;
module.exports.localResolve = localResolve;