'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var spawn = require('cross-spawn');

function pipeSpawn(cmd, params, opts) {
  var cp = spawn(cmd, params, opts);
  cp.stdout.pipe(process.stdout);
  cp.stderr.pipe(process.stderr);
  return new _promise2.default(function (resolve, reject) {
    cp.on('error', reject);
    cp.on('close', function (code) {
      if (code !== 0) {
        return reject(new Error(cmd + ' failed.'));
      }

      return resolve();
    });
  });
}

module.exports = pipeSpawn;