'use strict';

module.exports = function (err) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var message = typeof err === 'string' ? err : err.message;
  if (!message) {
    message = 'Unknown error';
  }

  if (err.fileName) {
    var fileName = err.fileName;
    if (err.loc) {
      fileName += ':' + err.loc.line + ':' + err.loc.column;
    }

    message = fileName + ': ' + message;
  }

  var stack = void 0;
  if (err.codeFrame) {
    stack = opts.color && err.highlightedCodeFrame || err.codeFrame;
  } else if (err.stack) {
    stack = err.stack.slice(err.stack.indexOf('\n') + 1);
  }

  return { message: message, stack: stack };
};