'use strict';

var _require = require('uglify-es'),
    minify = _require.minify;

var _require2 = require('serialize-to-js'),
    serialize = _require2.serialize;

function serializeObject(obj) {
  var shouldMinify = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  var code = 'module.exports = ' + serialize(obj) + ';';

  if (shouldMinify) {
    var minified = minify(code);
    if (minified.error) {
      throw minified.error;
    }

    code = minified.code;
  }

  return code;
}

module.exports = serializeObject;