'use strict';

var URL = require('url');
var path = require('path');

/**
 * Joins a path onto a URL, and normalizes Windows paths
 * e.g. from \path\to\res.js to /path/to/res.js.
 */
module.exports = function (publicURL, assetPath) {
  var url = URL.parse(publicURL);
  url.pathname = path.posix.join(url.pathname, URL.parse(assetPath).pathname);
  return URL.format(url);
};